(function () {
    "use strict";

    jQuery(document).ready(function () {
        const iframe = document.getElementById("currency-iframe");

        function authen() {
            jQuery.ajax({
                data: {
                    action: "mskmc_getCodeAuth", //Tên action, dữ liệu gởi lên cho server
                },
                method: "POST",
                url: ajaxurl,
                success: function (response) {
                    iframe.addEventListener("load", function () {
                        iframe.contentWindow.postMessage(
                            {
                                payload: {
                                    url: window.MSKMC_GLOBAL.restBase,
                                    token: response.data.code,
                                    tidioId: window.MSKMC_GLOBAL.tidio || "",
                                    clientSite: window.MSKMC_GLOBAL.clientSite || "",
                                    email: window.MSKMC_GLOBAL.email || "",
                                    purchaseCode: window.MSKMC_GLOBAL.purchaseCode || "",
                                    purchaseCodeLink: window.MSKMC_GLOBAL.purchaseCodeLink || "",
                                    productName: window.MSKMC_GLOBAL.productName || "",
                                    endpointVerification:
                                        window.MSKMC_GLOBAL.endpointVerification || "",
                                },
                                type: "@InitializePage/getWPInfoRequest",
                            },
                            "*"
                        );
                        iframe.classList.remove("hidden");
                    });

                    // check trường hợp login thành công
                    if (iframe) {
                        iframe.contentWindow.postMessage(
                            {
                                payload: {
                                    url: window.MSKMC_GLOBAL.restBase,
                                    token: response.data.code,
                                    tidioId: window.MSKMC_GLOBAL.tidio || "",
                                    clientSite: window.MSKMC_GLOBAL.clientSite || "",
                                    email: window.MSKMC_GLOBAL.email || "",
                                    purchaseCode: window.MSKMC_GLOBAL.purchaseCode || "",
                                    purchaseCodeLink: window.MSKMC_GLOBAL.purchaseCodeLink || "",
                                    productName: window.MSKMC_GLOBAL.productName || "",
                                    endpointVerification:
                                        window.MSKMC_GLOBAL.endpointVerification || "",
                                },
                                type: "@InitializePage/getWPInfoRequest",
                            },
                            "*"
                        );
                    }
                },
                error: function (response) {
                    iframe.addEventListener("load", function () {
                        iframe.contentWindow.postMessage(
                            {
                                payload: {
                                    url: window.MSKMC_GLOBAL.restBase,
                                    token: "",
                                    tidioId: window.MSKMC_GLOBAL.tidio || "",
                                    clientSite: window.MSKMC_GLOBAL.clientSite || "",
                                    email: window.MSKMC_GLOBAL.email || "",
                                    purchaseCode: window.MSKMC_GLOBAL.purchaseCode || "",
                                    purchaseCodeLink: window.MSKMC_GLOBAL.purchaseCodeLink || "",
                                    productName: window.MSKMC_GLOBAL.productName || "",
                                    endpointVerification:
                                        window.MSKMC_GLOBAL.endpointVerification || "",
                                },
                                type: "@InitializePage/getWPInfoRequest",
                            },
                            "*"
                        );
                        iframe.classList.remove("hidden");
                    });
                },
            });
        }

        authen();

        window.addEventListener(
            "message",
            (event) => {
                if (event.data.type === "@HasPassed") {
                    console.log(event.data);
                    if (event.data.payload.hasPassed === true) {
                        authen();
                    }
                }
            },
            false
        );
        jQuery("#btn-Revoke-Purchase-Code").on('click', function () {
            let status = confirm("Are you sure you want to revoke the Purchase Code?");
            if (status) {
                jQuery.ajax({
                    type: "POST",
                    url: ajaxurl,
                    data: {
                        action: "mskmc_revokePurchaseCode",
                        purchaseCode: MSKMC_GLOBAL.purchaseCode
                    },
                    success: function (response) {
                        if (response.status === 'success') {
                            location.reload();
                        } else {
                            alert(response.data.message);
                        }
                    },
                    error: function (jqXHR, error, errorThrown) {
                        alert(jqXHR.responseJSON.message);
                    },
                });
            }
        });
    });

})(jQuery);
